/* version 2, up to 2.23, enjoy 
 * VP
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct node
{
    int d;
    struct node*next ;
} Node ;
typedef Node * Node_ptr;
typedef Node * LinkedList;

typedef struct nodestr
{
    char * str;
    struct nodestr * next ;
} NodeStr ;
typedef NodeStr * NodeStr_ptr;
typedef NodeStr * LinkedListStr;

/* function prototypes */
Node_ptr createNode(int) ;
LinkedList prepend(LinkedList llst, Node_ptr node_ptr);
LinkedList append(LinkedList llst, Node_ptr node_ptr);
LinkedList appendrec(LinkedList llst, Node_ptr node_ptr);
void appendref(LinkedList * llst_ptr, Node_ptr node_ptr);
void report (LinkedList llst) ;
void print(LinkedList llst);
void printrec (LinkedList llst) ;
void invprintrec (LinkedList llst);
void invprintiter (LinkedList llst)  ;
void invprintiter2 (LinkedList llst)  ;
LinkedList insert(LinkedList y,int pos, Node_ptr node_ptr );
int getlength( LinkedList llst);
void printnodei(LinkedList llst, int i ) ;
int getlength2( LinkedList llst, int len);
int getlength3( LinkedList llst);
LinkedList linkedcopy(LinkedList llst) ;
LinkedList linkedcopy2(LinkedList llst);
LinkedList linkedcopyrec(LinkedList llst);
void deleteLinkedList(LinkedList llst) ;
void splitlistcopy(LinkedList mylst,
		LinkedList * oddlst_ptr,
		LinkedList * evenlst_ptr) ;
void splitlist(LinkedList mylst, 
		LinkedList * oddlst_ptr, 
		LinkedList * evenlst_ptr) ;
void multiplexcopy(LinkedList * mylst_ptr, 
		LinkedList firstlist,
		LinkedList secondlist);	
void multiplex(LinkedList * mylst_ptr,
			LinkedList firstlist,
			LinkedList secondlist);		
LinkedListStr prependStr (LinkedListStr lst, NodeStr_ptr node );
void printStr(LinkedListStr lst);
NodeStr_ptr createNodeStr(char * str) ;		
void deleteLinkedListStr(LinkedListStr llst);
LinkedListStr deepcopy (LinkedListStr srclist) ;
LinkedListStr deepcopyref (LinkedListStr srclist, LinkedListStr * destlist_ptr);
LinkedListStr shallowcopy(LinkedListStr srclist, LinkedListStr * destlist_ptr);			
void shallowdeletenostr(LinkedListStr shallow) ;

int main ( ) {
    LinkedList linked = NULL ;
    LinkedList copylinked = NULL;
    LinkedList copylinked2 = NULL;
    LinkedList copylinked3 = NULL;
    LinkedListStr strlst = NULL;
    
    linked = prepend(linked, createNode(1));
    linked = prepend(linked, createNode(-1));
    report(linked) ;
    linked = append(linked, createNode(2));
    report(linked) ;
    /* by value */
    linked = appendrec(linked, createNode(3));
    report(linked) ;
    /* by reference */
    appendref( &linked, createNode(4));
    report(linked) ;
    print(linked);
    printrec(linked);
    invprintrec (linked);
    invprintiter (linked);
    invprintiter2(linked);
    printf("insert\n");
    linked = insert(linked , 0 , createNode(10)) ;
    print(linked);
    linked = insert(linked , 1 , createNode(11)) ;
    print(linked);
    printf("len2: %d\n", getlength2(linked, 0));
    printf("len3: %d\n", getlength3(linked));
    printf("COPY\n");
	copylinked = linkedcopy(linked);
	print(copylinked);
	printf("COPY 2\n");
	copylinked2 = linkedcopy2(linked);
	print(copylinked2);
	
	printf("COPY REC\n");
	copylinked3 = linkedcopyrec(linked);
	print(copylinked3);
	deleteLinkedList(copylinked3);
	deleteLinkedList(copylinked);
	
	{
	LinkedList oddlst = NULL;
    LinkedList evenlst = NULL;
    
	printf("SPLIT COPY ODD EVEN\n");
	splitlistcopy(linked, &oddlst, &evenlst) ;
	print(oddlst);
	print(evenlst);
	deleteLinkedList(oddlst);
	deleteLinkedList(evenlst);
	
	printf("SPLIT NO COPY ODD EVEN\n");
	splitlist(copylinked2, &oddlst, &evenlst) ;
	print(oddlst);
	print(evenlst);
	printf("explain the values of addresses by comparing to COPY 2 above\n");
	
	printf("MULTIPLEX COPY\n");
	multiplexcopy(&copylinked3, oddlst, evenlst);
	print(copylinked3);
	deleteLinkedList(copylinked3);
	
	printf("MULTIPLEX NO COPY\n");
	multiplex(&copylinked3, oddlst, evenlst);
	print(copylinked3);
	deleteLinkedList(copylinked3);
	}
	deleteLinkedList(linked);
	
	printf("STR LIST\n");
	strlst = NULL;
	strlst = prependStr(strlst, createNodeStr("world!"));
	strlst = prependStr(strlst, createNodeStr("Hello"));
	printStr(strlst);

	{
	LinkedListStr strlstcopy ;	
	printf("DEEP COPY STR\n");
	strlstcopy = deepcopy (strlst) ;
	printStr(strlstcopy);
	deleteLinkedListStr(strlstcopy);
	}
	
	{
	LinkedListStr strlstcopy, strlstcopy2 ;	
	printf("DEEP COPY STR REF\n");
	deepcopyref (strlst, &strlstcopy) ;
	printStr(strlstcopy);
	strlstcopy2 = deepcopyref (strlst, &strlstcopy2) ;
	printStr(strlstcopy2);
	deleteLinkedListStr(strlstcopy);
	deleteLinkedListStr(strlstcopy2);
	}
	
	{
	LinkedListStr strlstcopy, strlstcopy2 ;	
	printf("SHALLOW COPY STR REF\n");
	printf("src\n");
	printStr(strlst);
	printf("copies\n");
	shallowcopy (strlst, &strlstcopy) ;
	printStr(strlstcopy);
	strlstcopy2 = shallowcopy (strlst, &strlstcopy2) ;
	printStr(strlstcopy2);
	printf("notice same addresses for strings\n");
	printf("change one to change all (has same length with prior string so no buffer overflow)\n");
	strcpy(strlstcopy2->str,"HELLO");
	printStr(strlstcopy);
	printStr(strlstcopy2);
	deleteLinkedListStr(strlstcopy);
	shallowdeletenostr(strlstcopy2); /* food for thought! */ 
	}
	
	shallowdeletenostr(strlst); /* food for thought! */
	return 0 ;
}

void report (LinkedList llst)  {
    if (llst==NULL) { printf("\n"); return ;}
    printf("%d %p::", llst->d,  (void *) llst->next) ;
    report (llst->next);
    return ;
}


/* ex2.1 */
Node_ptr createNode(int d) {
    Node_ptr temp_ptr ;
    temp_ptr = malloc(sizeof (Node));
    temp_ptr -> d = d;
    temp_ptr -> next = NULL;
   return temp_ptr;
}

/* ex2.2 */
LinkedList prepend(LinkedList llst, Node_ptr node_ptr) {
    if (node_ptr == NULL) return llst;
    node_ptr -> next = llst;
    return node_ptr;
}

/* ex2.3 */
LinkedList append(LinkedList llst, Node_ptr node_ptr) {
   Node_ptr iter_ptr;
   if (llst==NULL) return node_ptr;
   if (node_ptr == NULL) return llst ;

   for (iter_ptr = llst; iter_ptr -> next != NULL ;
                iter_ptr = iter_ptr->next );
   /* iter_ptr points to last element in the linked list */
   iter_ptr -> next = node_ptr;

   return llst;
}

/* ex2.4 */
LinkedList appendrec(LinkedList llst, Node_ptr node_ptr) {
    if (node_ptr == NULL) return llst ;
    if (llst == NULL) return node_ptr ;
    llst->next = appendrec ( llst->next, node_ptr) ;
    return llst;
}

/* ex2.5 by reference and recursive */
void appendref(LinkedList * llst_ptr, Node_ptr node_ptr) {

    if (node_ptr == NULL) return ;

    /* *llst_ptr IS linked */
    if ( *llst_ptr == NULL)  {
            *llst_ptr = node_ptr;
            return ;
        }

    appendref ( & ((*llst_ptr)->next), node_ptr) ;

    return ;
}

/* ex2.6 */
void print(LinkedList llst) {
    printf("PRINT\n");
    for ( ; llst!=NULL; llst = llst->next ) {
       printf("%d %p::", llst->d,  (void *) llst->next) ;
    }
    printf("\n");
    return ;
}
/* ex2.7 */
void printrec (LinkedList llst)  {
    if (llst==NULL) { printf(" was PRINTREC\n"); return ;}
    printf("%d %p::", llst->d,  (void *) llst->next) ;
    printrec (llst->next);
    return ;
}

/* ex2.8 */
void invprintrec (LinkedList llst)  {
    if (llst==NULL) { printf("INVPRINTREC\n"); return ;}
    invprintrec (llst->next);
    printf("%d %p::", llst->d,  (void *) llst->next) ;
    return ;
}

/* ex2.9  */
void invprintiter (LinkedList llst)  {
    Node_ptr iter_ptr ;
    Node_ptr * arr_iter_ptr = NULL;
    int i = 0;
    printf("\nINVPRINTITER\n");
    if (llst==NULL) {  return ;}

    for (iter_ptr = llst; iter_ptr != NULL ;
                iter_ptr = iter_ptr->next ) {
    arr_iter_ptr = realloc( arr_iter_ptr, (i+1) * sizeof (Node_ptr) );
    arr_iter_ptr[i] = iter_ptr;
    i++; /* i contains current number of nodes */
    }

    for ( ; i>0; i--) {
        printf("%d %p::",
        arr_iter_ptr[i-1] -> d,
        (void *) arr_iter_ptr[i-1] -> next);
    }
    printf("\n");
    free(arr_iter_ptr);
    return ;
}

/* ex2.9 with (hidden) nested for loops*/

int getlength( LinkedList llst) {
    if (llst==NULL) return 0;
    return 1 + getlength(llst->next) ;
}

int getlength2( LinkedList llst, int len) {
    if (llst==NULL) return len;
    return getlength2(llst->next, len + 1) ;
}

int getlength3(LinkedList llst) {
	int len = 0;
	while (llst!=NULL) {
		len = len + 1;
		llst=llst->next;
	}
	return len;
}


/* print ith node of list */
void printnodei(LinkedList llst, int i ) {
    int j = 0;
    for ( ;llst!=NULL && j<i ; llst=llst->next) {
        j++;
    }
    if (llst==NULL) {printf("not enough nodes"); return ;}
    printf("%d %p (%d)::",llst -> d,(void *) llst -> next, j);
    return ;
}

void invprintiter2 (LinkedList llst)   {
    int count;
    int j;
    printf("\nINVPRINTITER2\n");
    count = getlength(llst);
    for (j = count-1; j>=0; j--) {
        printnodei(llst, j) ;
    }
    return ;
}

/* ex 2.10 */
LinkedList insert(LinkedList y,int pos, Node_ptr node_ptr ) {
    if (y==NULL && pos > 0 ) {printf(" not possible"); return y ;}
    if (node_ptr == NULL) { printf("empty node"); return y;}
    if (pos == 0 ) {
            node_ptr -> next = y;
            return node_ptr;
        }
    y->next = insert (y->next, pos - 1, node_ptr) ;
    return y ;
}
/* ex 2.11 */
Node_ptr nodecopy(Node_ptr node_ptr) {
    Node_ptr copy_ptr;
    copy_ptr = malloc(sizeof (Node)) ;
    copy_ptr->d = node_ptr ->d ;
    copy_ptr->next =NULL ;
    return copy_ptr;
}
/* can use createNode */
Node_ptr nodecopy2(Node_ptr node_ptr) {
   return createNode(node_ptr->d);
}
/* ex2.12 */
/* solution with append and create node */
LinkedList linkedcopy(LinkedList llst) {
	LinkedList copy  = NULL;
	
	while (llst!= NULL) {
		copy = append(copy, createNode(llst->d));	
		llst = llst -> next;
	} 
	
	return copy;
}
/* solution with createNode. Which one uses less steps? */
LinkedList linkedcopy2(LinkedList llst) {
	LinkedList copy  = NULL;
	Node_ptr copytail_ptr = NULL;
	
	while (llst != NULL) {
		if (copytail_ptr==NULL) {
			copytail_ptr = createNode(llst->d);
			copy = copytail_ptr;
		}
		else {
			copytail_ptr->next =createNode(llst->d);
			copytail_ptr = copytail_ptr->next;
		}
		llst = llst -> next;
	} 
	return copy;
}

/* ex2.13 */
LinkedList linkedcopyrec(LinkedList llst) {
	LinkedList copy  ;
	if (llst==NULL) return NULL;
	copy = createNode(llst->d);
	copy->next = linkedcopyrec(llst->next) ;
	return copy;
}

/* ex2.14 */
void deleteLinkedList(LinkedList llst) {
	if (llst==NULL) return ;
	deleteLinkedList(llst->next);
	free(llst);
	return ;	
}

/* ex2.15 */
/* solution with append and createNode */
void splitlistcopy(LinkedList mylst,
		LinkedList * oddlst_ptr,
		LinkedList * evenlst_ptr) {
	*oddlst_ptr = NULL;
	*evenlst_ptr = NULL;
	while (mylst != NULL) {
		if (mylst->d % 2 == 0) {
			*evenlst_ptr = append (*evenlst_ptr, createNode(mylst->d));
		}
		else {
			*oddlst_ptr = append (*oddlst_ptr, createNode(mylst->d));
		}
		mylst = mylst -> next ;
	}	
	return ;		
}
/* can you write a solution which requires less steps ? */

/* ex2.16 (notice that no new node is created!) */
/* solution with append */
void splitlist(LinkedList mylst, 
		LinkedList * oddlst_ptr, 
		LinkedList * evenlst_ptr) {
	*oddlst_ptr = NULL;
	*evenlst_ptr = NULL;
	while (mylst != NULL) {
		Node_ptr temp = mylst->next; /* copy address of next */
		mylst->next = NULL ; 		/* NULL next guarantee termination 
									   of partial lists */
		if (mylst -> d % 2 == 0) 
			*evenlst_ptr  = append(*evenlst_ptr, mylst);
		else
			*oddlst_ptr  = append(*oddlst_ptr, mylst);
		mylst = temp;
	}
	
	return ;
}

/* ex2.17 use createNode and append */
void multiplexcopy(LinkedList * mylst_ptr, 
		LinkedList firstlist,
		LinkedList secondlist) {
	
	*mylst_ptr = NULL;
	while (firstlist != NULL || secondlist != NULL) {
		if (firstlist!=NULL) {
			*mylst_ptr = append(*mylst_ptr, createNode(firstlist->d));
			firstlist = firstlist -> next;
		}
		if (secondlist!=NULL) {
			*mylst_ptr = append(*mylst_ptr, createNode(secondlist->d));
			secondlist = secondlist -> next;
		}
	}		
	return ;			
}

/* ex2.18 */
void multiplex(LinkedList * mylst_ptr,
			LinkedList firstlist,
			LinkedList secondlist) {
	*mylst_ptr = NULL;			
	while (firstlist != NULL || secondlist != NULL) {
		if (firstlist!=NULL) {
			Node_ptr firsttemp = firstlist->next ;
			firstlist -> next = NULL;
			*mylst_ptr = append(*mylst_ptr, firstlist);
			firstlist = firsttemp ;
		}
		if (secondlist!=NULL) {
			Node_ptr secondtemp = secondlist->next;
			secondlist->next = NULL;
			*mylst_ptr = append(*mylst_ptr, secondlist);
			secondlist = secondtemp;
		}	
	}			
	return ;				
}

/* ex2.19 */
NodeStr_ptr createNodeStr(char * str) {
    NodeStr_ptr temp_ptr ;
    temp_ptr = malloc(sizeof (NodeStr));
    temp_ptr -> str = malloc((strlen(str)+1)*sizeof(char));
    strcpy(temp_ptr -> str, str);
    temp_ptr -> next = NULL;
   return temp_ptr;
}

/* helper functions for LinkedListStr : prependStr, printStr */
LinkedListStr prependStr (LinkedListStr lst, NodeStr_ptr node ) {
	if (node == NULL) return lst;
	node->next = lst;	
	return node;
}
void printStr(LinkedListStr lst) {
	if (lst == NULL) {printf("\n"); return ;}
	printf("%s (node at %p, str at %p)::", lst->str, (void *) lst, (void *) lst->str);
	printStr(lst->next);		
	return ;
}

/* ex2.20: iterative implementation (as requested) */

void deleteLinkedListStr(LinkedListStr llst) {
	while (llst!=NULL) {
		LinkedListStr temp = llst->next;
		free(llst->str);
		free(llst);
		llst = temp;
	}
	return ;
}

/* a recursive implementation */
void deleteLinkedListStrRec(LinkedListStr llst) {
	if (llst==NULL) return ;
	deleteLinkedListStrRec(llst->next) ;
	free(llst->str);
	free(llst);
	return ;
}

/* ex2.21 */

LinkedListStr deepcopy (LinkedListStr srclist) {
	LinkedListStr copy = NULL;
	while (srclist != NULL) {
		NodeStr_ptr temp = malloc(sizeof (NodeStr));
		if (temp==NULL) return NULL;
		temp->str = malloc((strlen(srclist->str)+1)*sizeof(char));
		if (temp->str == NULL) return NULL;
		strcpy(temp->str, srclist->str);
		temp->next = NULL;
		if (copy == NULL) {
			copy = temp;
		} else
		{ 
			copy->next = temp;
		}
		srclist = srclist->next;
	}
	return copy;
}

/* ex2.22 */
LinkedListStr deepcopyref (LinkedListStr srclist, LinkedListStr * destlist_ptr) {
	*destlist_ptr = NULL;
	while (srclist != NULL) {
		NodeStr_ptr temp = malloc(sizeof (NodeStr));
		if (temp==NULL) { *destlist_ptr = NULL; return NULL; }
		temp->str = malloc((strlen(srclist->str)+1)*sizeof(char));
		if (temp->str == NULL) { *destlist_ptr = NULL; return NULL;}
		strcpy(temp->str, srclist->str);
		temp->next = NULL;
		if (*destlist_ptr == NULL) {
			*destlist_ptr = temp;
		} else
		{ 
			(*destlist_ptr) ->next = temp;
		}
		srclist = srclist->next;
	}
	return *destlist_ptr;
}

/* ex2.23 */
LinkedListStr shallowcopy(LinkedListStr srclist, LinkedListStr * destlist_ptr) {
	*destlist_ptr = NULL;
	while (srclist != NULL) {
		NodeStr_ptr temp = malloc(sizeof (NodeStr));
		if (temp==NULL) { *destlist_ptr = NULL; return NULL; }
		temp->str = srclist->str ; /* copies address only, does not copy string */
		temp->next = NULL;
		if (*destlist_ptr == NULL) {
			*destlist_ptr = temp;
		} else
		{ 
			(*destlist_ptr) ->next = temp;
		}
		srclist = srclist->next;
	}
	return *destlist_ptr;
}

/* helper shallow delete (to avoid double freeing str points 
   only to be called on shallow copies with already freed strings 
 */
void shallowdeletenostr(LinkedListStr shallow) {
	while (shallow!=NULL) {
		LinkedListStr temp = shallow->next;
		free(shallow); 
		shallow = temp;
	}
	return ;
}

